/*	File = VAR.C
	 This file defines all Global Variables.
	*/

/* 	Define data arrays. Individual arrays, rather than
	structures, are use so that FUZZY can be ported to
	other languages without structures...Small-C, Basic
	Fortran......etc						*/

/*	Arrays for the INPUTS
	Input Names	Char
	Input Units	Char
	Input range	Int
	Members		Char
	Points		Int			
	*/
char	In_Name[(NUM_IN_NAME) * (NAMESIZE)];	
char	In_Units[(NUM_IN_NAME)*(UNITSIZE)];
int	In_Min[NUM_IN_NAME];
int	In_Max[NUM_IN_NAME];
char	In_Func[(NUM_IN_NAME)*(NUM_IN_FUNC) * (FUNCSIZE)];	
int	In_Points[(NUM_IN_NAME)*(NUM_IN_FUNC)*(NUM_IN_POINTS)];

/*	Arrays for the OUTPUTS
	Output Names	Char
	Output Units	Char
	Output range	Int
	Members		Char
	Points		Int			
	*/
char	Out_name[(NUM_OUT_NAME) * (NAMESIZE)];	
char	Out_units[(NUM_OUT_NAME)*(UNITSIZE)];
int	Out_min[NUM_OUT_NAME];
int	Out_max[NUM_OUT_NAME];
char	Out_func[(NUM_OUT_NAME)*(NUM_OUT_FUNC) * (FUNCSIZE)];	
int	Out_points[(NUM_OUT_NAME)*(NUM_OUT_FUNC)*(NUM_OUT_POINTS)];

/*	Integer Array to hold FCBs which represent Rules.		*/
int	Rules[MAX_RULE_SIZE];	/* Place to store FCBs that are RULES.	*/
int	Rules_ptr;		/* pointer to current RULE.		*/
char	File_Name[20];		/* Base (generic) filename for ALL I/O.	*/
char	Kb_Dirty;		/* == YES when Knowledge Base changed.	*/
char	Version[6];		/* Place to keep the Version number.	*/
